clear all
close all

l=0.61; %meter
g=9.81;
teta0=pi/4;

%numerico (nao-linearizado) ordem 2
funcao = @(t,teta) [teta(2); -g/l*sin(teta(1))]; 
tspan=[0:0.01:pi/2]; % intervalo
y0=[teta0;0]; % cond. iniciais
[t,teta] = ode23(funcao,tspan,y0);

%numerico (nao-linearizado) ordem 4
funcao = @(t,teta) [teta(2); -g/l*sin(teta(1))]; 
[t2,teta2] = ode45(funcao,tspan,y0);

%exato linearizado
teta_lin=teta0*cos(sqrt(g/l)*t);
velocidade=teta0*(-sqrt(g/l))*sin(sqrt(g/l)*t);

subplot(2,2,1)
plot(t,teta_lin,t,teta(:,1),'r')
title 'teta'
subplot(2,2,2)
plot(t,velocidade,t,teta(:,2),'r')
title 'velocity'
subplot(2,2,3)
plot(t,teta_lin-teta(:,1), t,teta_lin-teta2(:,1))
title 'error teta'
legend ('RK2', 'RK4')
subplot(2,2,4)
plot(t,velocidade-teta(:,2), t,velocidade-teta2(:,2))
title 'error velocity'
legend ('RK2', 'RK4')

error_rk2_4=teta(:,1)-teta2(:,1)
mean_error_rk2_4=mean(error_rk2_4)

mean_error_num_lin=mean(teta_lin-teta2(:,1))

